=== debian/changelog ===
cduce (0.6.0-1) unstable; urgency=medium

  * New upstream release (Closes: #731818)
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Mar 2014 09:49:39 +0100
