=== debian/watch ===
version=3
http://www.cduce.org/download.html download/cduce-([0-9\.]*)\.tar\.gz
